Index: binaries/data/mods/public/maps/random/BaseTerrainDiamondSquare.js
===================================================================
--- binaries/data/mods/public/maps/random/BaseTerrainDiamondSquare.js	(revision 0)
+++ binaries/data/mods/public/maps/random/BaseTerrainDiamondSquare.js	(working copy)
@@ -0,0 +1,146 @@
+/**
+*	ToDo:
+*	Add resources at start locations
+*	Add stone and metal
+*	Place start locations of one team close to each other
+*
+*	Add parameters for match setup screen (for later use and demonstration)
+*
+*	Extract some functions to an RMGEN lib
+*	Sort out unneeded functions calling other functions
+*	Clean up
+*/
+
+RMS.LoadLibrary("rmgen");
+
+const BUILDING_ANGlE = -PI/4;
+
+/**
+* initialize map
+*/
+
+log("Initializing map...");
+
+InitMap();
+
+var numPlayers = g_MapSettings.PlayerData.length;
+var mapSize = getMapSize();
+
+
+/**
+* Actually do stuff
+*/
+
+/**
+* Set target min and max height depending on map size to make average steepness about the same on all map sizes
+*/
+var heightRange = {"min": MIN_HEIGHT * (mapSize + 512) / 1024 / 8, "max": MAX_HEIGHT * (mapSize + 512) / 1024 / 8};
+
+/**
+* Set average water coverage
+*/
+var averageWaterCoverage = 1/5; // NOTE: Since erosion is not predictable actual water coverage might vary much with the same values
+var waterHeight = -MIN_HEIGHT + heightRange.min + averageWaterCoverage * (heightRange.max - heightRange.min);
+var waterHeightAdjusted = waterHeight + MIN_HEIGHT;
+setWaterHeight(waterHeight);
+
+/**
+*  Generate initial reliefmap
+*/
+setBaseTerrainDiamondSquare(heightRange.min, heightRange.max, 0.5);
+
+
+/**
+* Apply simple erosion
+*/
+for (var i = 0; i < 5; i++)
+	globalSmoothHeightmap(0.5);
+
+
+/**
+* Place start locations and apply terrain texture and decorative props by height
+*/
+
+/**
+* Set random biome
+*/
+randomizeBiome();
+
+/**
+* Define texture textures and decorative props (and density) by height
+*/
+var textueByHeight = [];
+textueByHeight.push({"height": heightRange.min + 1/3 * (waterHeightAdjusted - heightRange.min), "texture": rbt15, "actor": [rbe9, 0.2]});
+textueByHeight.push({"height": heightRange.min + 2/3 * (waterHeightAdjusted - heightRange.min), "texture": rbt15, "actor": [undefined, 0]});
+textueByHeight.push({"height": heightRange.min + 3/3 * (waterHeightAdjusted - heightRange.min), "texture": rbt15, "actor": [rba3, 0.2]});
+textueByHeight.push({"height": waterHeightAdjusted + 1/9 * (heightRange.max - waterHeightAdjusted), "texture": rbt14, "actor": [rbe5, 0.1]});
+textueByHeight.push({"height": waterHeightAdjusted + 2/9 * (heightRange.max - waterHeightAdjusted), "texture": rbt8, "actor": [undefined, 0]});
+textueByHeight.push({"height": waterHeightAdjusted + 3/9 * (heightRange.max - waterHeightAdjusted), "texture": rbt9, "actor": [undefined, 0]});
+textueByHeight.push({"height": waterHeightAdjusted + 4/9 * (heightRange.max - waterHeightAdjusted), "texture": rbt1, "actor": [undefined, 0]});
+textueByHeight.push({"height": waterHeightAdjusted + 5/9 * (heightRange.max - waterHeightAdjusted), "texture": rbt5, "actor": [rbe3, 0.2]});
+textueByHeight.push({"height": waterHeightAdjusted + 6/9 * (heightRange.max - waterHeightAdjusted), "texture": rbt2, "actor": [rbe1, 0.4]});
+textueByHeight.push({"height": waterHeightAdjusted + 7/9 * (heightRange.max - waterHeightAdjusted), "texture": rbt3, "actor": [rbe2, 0.4]});
+textueByHeight.push({"height": waterHeightAdjusted + 8/9 * (heightRange.max - waterHeightAdjusted), "texture": rbt7, "actor": [rbe4, 0.2]});
+textueByHeight.push({"height": waterHeightAdjusted + 9/9 * (heightRange.max - waterHeightAdjusted), "texture": rbt4, "actor": [undefined, 0]});
+
+/**
+* Get start locations
+*/
+rescaleHeightmap(heightRange.min, heightRange.max);
+var startLocations = getStartLocationsByHeightmap({"min": textueByHeight[4].height, "max": textueByHeight[5].height});
+
+/**
+* Smooth ground at start locations and place starting entities
+*/
+var playerHeight = (textueByHeight[4].height + textueByHeight[5].height) / 2;
+for (var p = 0; p < g_MapSettings.PlayerData.length - 1; p++)
+{
+	log("p = " + uneval(p));
+	log("startLocations[" + p + "] = " + uneval(startLocations[p]));
+	rectangularSmoothToHeight(startLocations[p], 30, 30, playerHeight);
+	placeCivDefaultEntities(startLocations[p].x, startLocations[p].y, p + 1, BUILDING_ANGlE, {"iberWall": true});
+}
+
+/**
+* Normalize and apply reliefmap
+*/
+rescaleHeightmap(heightRange.min, heightRange.max);
+
+/**
+* Place terrain texture and decorative props by height
+*/
+for(var x = 0; x < mapSize; x++)
+{
+	for (var y = 0; y < mapSize; y++)
+	{
+		var textureMinHeight = heightRange.min;
+		for (var i = 0; i < textueByHeight.length; i++)
+		{
+			if (g_Map.height[x][y] >= textureMinHeight && g_Map.height[x][y] <= textueByHeight[i].height)
+			{
+				if (typeof(textueByHeight[i].texture) == "string")
+					g_Map.setTexture(x, y, textueByHeight[i].texture);
+				else
+					g_Map.setTexture(x, y, textueByHeight[i].texture[randInt(textueByHeight[i].texture.length)]);
+				if (textueByHeight[i].actor[0])
+				{
+					var scaleByDistToPlayer = 1; // ToDo: Make an approximate faster range check!!!
+					for (var p = 0; p < g_MapSettings.PlayerData.length; p++)
+						scaleByDistToPlayer = min(getDistance(x, y, startLocations[p].x, startLocations[p].y) / 50, scaleByDistToPlayer);
+					if (randFloat() < textueByHeight[i].actor[1] * scaleByDistToPlayer)
+						placeObject(x + 0.5, y + 0.5, textueByHeight[i].actor[0], 0, randFloat(0, 2*PI));
+				}
+				break;
+			}
+			else
+			{
+				textureMinHeight = textueByHeight[i].height;
+			}
+		}
+	}
+}
+
+/**
+* Export map data
+*/
+ExportMap();
Index: binaries/data/mods/public/maps/random/belgian_uplands.js
===================================================================
--- binaries/data/mods/public/maps/random/belgian_uplands.js	(revision 17723)
+++ binaries/data/mods/public/maps/random/belgian_uplands.js	(working copy)
@@ -1,14 +1,19 @@
-// Prepare progress calculation
+/**
+ * Prepare progress calculation
+ */
 var timeArray = [];
 timeArray.push(new Date().getTime());
 
-// Importing rmgen libraries
+/**
+ * Importing rmgen libraries
+ */
 RMS.LoadLibrary("rmgen");
 
 const BUILDING_ANGlE = -PI/4;
 
-// initialize map
-
+/**
+ * initialize map
+ */
 log("Initializing map...");
 
 InitMap();
@@ -17,15 +22,13 @@
 var mapSize = getMapSize();
 
 
-//////////
-// Heightmap functionality
-//////////
+/**
+ * Heightmap functionality
+ */
 
-// Some general heightmap settings
-const MIN_HEIGHT = - SEA_LEVEL; // 20, should be set in the libs!
-const MAX_HEIGHT = 0xFFFF/HEIGHT_UNITS_PER_METRE - SEA_LEVEL; // A bit smaler than 90, should be set in the libs!
-
-// Add random heightmap generation functionality
+/**
+ * Add random heightmap generation functionality
+ */
 function getRandomReliefmap(minHeight, maxHeight)
 {
 	minHeight = (minHeight || MIN_HEIGHT);
@@ -35,10 +38,10 @@
 	if (maxHeight > MAX_HEIGHT)
 		warn("getRandomReliefmap: Argument maxHeight is smaler then the supported maximum height of " + MAX_HEIGHT + " (const MAX_HEIGHT): " + maxHeight)
 	var reliefmap = [];
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
 		reliefmap.push([]);
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			reliefmap[x].push(randFloat(minHeight, maxHeight));
 		}
@@ -46,28 +49,32 @@
 	return reliefmap;
 }
 
-// Apply a heightmap
+/**
+ * Apply a heightmap
+ */
 function setReliefmap(reliefmap)
 {
 	// g_Map.height = reliefmap;
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			setHeight(x, y, reliefmap[x][y]);
 		}
 	}
 }
 
-// Get minimum and maxumum height used in a heightmap
+/**
+ * Get minimum and maxumum height used in a heightmap
+ */
 function getMinAndMaxHeight(reliefmap)
 {
 	var height = {};
 	height.min = Infinity;
 	height.max = -Infinity;
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			if (reliefmap[x][y] < height.min)
 				height.min = reliefmap[x][y];
@@ -78,7 +85,9 @@
 	return height;
 }
 
-// Rescale a heightmap (Waterlevel is not taken into consideration!)
+/**
+ * Rescale a heightmap (Waterlevel is not taken into consideration!)
+ */
 function getRescaledReliefmap(reliefmap, minHeight, maxHeight)
 {
 	var newReliefmap = deepcopy(reliefmap);
@@ -89,9 +98,9 @@
 	if (maxHeight > MAX_HEIGHT)
 		warn("getRescaledReliefmap: Argument maxHeight is smaler then the supported maximum height of " + MAX_HEIGHT + " (const MAX_HEIGHT): " + maxHeight)
 	var oldHeightRange = getMinAndMaxHeight(reliefmap);
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			newReliefmap[x][y] = minHeight + (reliefmap[x][y] - oldHeightRange.min) / (oldHeightRange.max - oldHeightRange.min) * (maxHeight - minHeight);
 		}
@@ -99,18 +108,20 @@
 	return newReliefmap
 }
 
-// Applying decay errosion (terrain independent)
+/**
+ * Applying decay errosion (terrain independent)
+ */
 function getHeightErrosionedReliefmap(reliefmap, strength)
 {
 	var newReliefmap = deepcopy(reliefmap);
 	strength = (strength || 1.0); // Values much higher then 1 (1.32+ for an 8 tile map, 1.45+ for a 12 tile map, 1.62+ @ 20 tile map, 0.99 @ 4 tiles) will result in a resonance disaster/self interference
 	var map = [[1, 0], [1, 1], [0, 1], [-1, 1], [-1, 0], [-1, -1], [0, -1], [1, -1]]; // Default
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			var div = 0;
-			for (var i = 0; i < map.length; i++)
+			for (var i = 0; i < map.length; ++i)
 				newReliefmap[x][y] += strength / map.length * (reliefmap[(x + map[i][0] + mapSize + 1) % (mapSize + 1)][(y + map[i][1] + mapSize + 1) % (mapSize + 1)] - reliefmap[x][y]); // Not entirely sure if scaling with map.length is perfect but tested values seam to indicate it is
 		}
 	}
@@ -118,14 +129,18 @@
 }
 
 
-//////////
-// Prepare for hightmap munipulation
-//////////
+/**
+ * Prepare for hightmap munipulation
+ */
 
-// Set target min and max height depending on map size to make average stepness the same on all map sizes
-var heightRange = {"min": MIN_HEIGHT * mapSize / 8192, "max": MAX_HEIGHT * mapSize / 8192};
+/**
+ * Set target min and max height depending on map size to make average stepness the same on all map sizes
+ */
+var heightRange = { "min": MIN_HEIGHT * (mapSize + 256) / 8192, "max": MAX_HEIGHT * (mapSize + 256) / 8192 };
 
-// Set average water coverage
+/**
+ * Set average water coverage
+ */
 var averageWaterCoverage = 1/3; // NOTE: Since errosion is not predictable actual water coverage might differ much with the same value
 if (mapSize < 200) // Sink the waterlevel on tiny maps to ensure enough space
 	averageWaterCoverage = 2/3 * averageWaterCoverage;
@@ -134,77 +149,104 @@
 setWaterHeight(waterHeight);
 
 
-//////////
-// Prepare terrain texture by height placement
-//////////
-
+/**
+ * Prepare terrain texture by height placement
+ */
 var textueByHeight = [];
 
-// Deep water
-textueByHeight.push({"upperHeightLimit": heightRange.min + 1/3 * (waterHeightAdjusted - heightRange.min), "terrain": "temp_sea_rocks"});
-// Medium deep water (with fish)
-var terreins = ["temp_sea_weed"];
-terreins = terreins.concat(terreins, terreins, terreins, terreins);
-terreins = terreins.concat(terreins, terreins, terreins, terreins);
-terreins.push("temp_sea_weed|gaia/fauna_fish");
-textueByHeight.push({"upperHeightLimit": heightRange.min + 2/3 * (waterHeightAdjusted - heightRange.min), "terrain": terreins});
-// Flat Water
-textueByHeight.push({"upperHeightLimit": heightRange.min + 3/3 * (waterHeightAdjusted - heightRange.min), "terrain": "temp_mud_a"});
-// Water surroundings/bog (with stone/metal some rabits and bushes)
-var terreins = ["temp_plants_bog", "temp_plants_bog_aut", "temp_dirt_gravel_plants", "temp_grass_d"];
-terreins = terreins.concat(terreins, terreins, terreins, terreins, terreins);
-terreins = ["temp_plants_bog|gaia/flora_bush_temperate"].concat(terreins, terreins);
-terreins = ["temp_dirt_gravel_plants|gaia/geology_metal_temperate", "temp_dirt_gravel_plants|gaia/geology_stone_temperate", "temp_plants_bog|gaia/fauna_rabbit"].concat(terreins, terreins);
-terreins = ["temp_plants_bog_aut|gaia/flora_tree_dead"].concat(terreins, terreins);
-textueByHeight.push({"upperHeightLimit": waterHeightAdjusted + 1/6 * (heightRange.max - waterHeightAdjusted), "terrain": terreins});
-// Juicy grass near bog
-textueByHeight.push({"upperHeightLimit": waterHeightAdjusted + 2/6 * (heightRange.max - waterHeightAdjusted),
-	"terrain": ["temp_grass", "temp_grass_d", "temp_grass_long_b", "temp_grass_plants"]});
-// Medium level grass
-// var testActor = "actor|geology/decal_stone_medit_a.xml";
-textueByHeight.push({"upperHeightLimit": waterHeightAdjusted + 3/6 * (heightRange.max - waterHeightAdjusted),
-	"terrain": ["temp_grass", "temp_grass_b", "temp_grass_c", "temp_grass_mossy"]});
-// Long grass near forest border
-textueByHeight.push({"upperHeightLimit": waterHeightAdjusted + 4/6 * (heightRange.max - waterHeightAdjusted),
-	"terrain": ["temp_grass", "temp_grass_b", "temp_grass_c", "temp_grass_d", "temp_grass_long_b", "temp_grass_clovers_2", "temp_grass_mossy", "temp_grass_plants"]});
-// Forest border (With wood/food plants/deer/rabits)
-var terreins = ["temp_grass_plants|gaia/flora_tree_euro_beech", "temp_grass_mossy|gaia/flora_tree_poplar", "temp_grass_mossy|gaia/flora_tree_poplar_lombardy",
+/**
+ * Deep water
+ */
+textueByHeight.push({ "upperHeightLimit": heightRange.min + 1/3 * (waterHeightAdjusted - heightRange.min), "terrain": "temp_sea_rocks" });
+
+/**
+ * Medium water (with fish)
+ */
+var terrains = ["temp_sea_weed"];
+terrains = terrains.concat(terrains, terrains, terrains, terrains);
+terrains = terrains.concat(terrains, terrains, terrains, terrains);
+terrains.push("temp_sea_weed|gaia/fauna_fish");
+textueByHeight.push({ "upperHeightLimit": heightRange.min + 2/3 * (waterHeightAdjusted - heightRange.min), "terrain": terrains });
+
+/**
+ * Flat Water
+ */
+textueByHeight.push({ "upperHeightLimit": heightRange.min + 3/3 * (waterHeightAdjusted - heightRange.min), "terrain": "temp_mud_a" });
+
+/**
+ * Water surroundings/bog (with stone/metal some rabits and bushes)
+ */
+var terrains = ["temp_plants_bog", "temp_plants_bog_aut", "temp_dirt_gravel_plants", "temp_grass_d"];
+terrains = terrains.concat(terrains, terrains, terrains, terrains, terrains);
+terrains = ["temp_plants_bog|gaia/flora_bush_temperate"].concat(terrains, terrains);
+terrains = ["temp_dirt_gravel_plants|gaia/geology_metal_temperate", "temp_dirt_gravel_plants|gaia/geology_stone_temperate", "temp_plants_bog|gaia/fauna_rabbit"].concat(terrains, terrains);
+terrains = ["temp_plants_bog_aut|gaia/flora_tree_dead"].concat(terrains, terrains);
+textueByHeight.push({ "upperHeightLimit": waterHeightAdjusted + 1/6 * (heightRange.max - waterHeightAdjusted), "terrain": terrains });
+
+/**
+ * Juicy grass near bog
+ */
+textueByHeight.push({ "upperHeightLimit": waterHeightAdjusted + 2/6 * (heightRange.max - waterHeightAdjusted),
+	"terrain": ["temp_grass", "temp_grass_d", "temp_grass_long_b", "temp_grass_plants"] });
+
+/**
+ * Medium level grass
+ */
+textueByHeight.push({ "upperHeightLimit": waterHeightAdjusted + 3/6 * (heightRange.max - waterHeightAdjusted),
+	"terrain": ["temp_grass", "temp_grass_b", "temp_grass_c", "temp_grass_mossy"] });
+
+/**
+ * Long grass near forest border
+ */
+textueByHeight.push({ "upperHeightLimit": waterHeightAdjusted + 4/6 * (heightRange.max - waterHeightAdjusted),
+	"terrain": ["temp_grass", "temp_grass_b", "temp_grass_c", "temp_grass_d", "temp_grass_long_b", "temp_grass_clovers_2", "temp_grass_mossy", "temp_grass_plants"] });
+
+/**
+ * Forest border (With wood/food plants/deer/rabits)
+ */
+var terrains = ["temp_grass_plants|gaia/flora_tree_euro_beech", "temp_grass_mossy|gaia/flora_tree_poplar", "temp_grass_mossy|gaia/flora_tree_poplar_lombardy",
 	"temp_grass_long|gaia/flora_bush_temperate", "temp_mud_plants|gaia/flora_bush_temperate", "temp_mud_plants|gaia/flora_bush_badlands",
 	"temp_grass_long|gaia/flora_tree_apple", "temp_grass_clovers|gaia/flora_bush_berry", "temp_grass_clovers_2|gaia/flora_bush_grapes",
 	"temp_grass_plants|gaia/fauna_deer", "temp_grass_long_b|gaia/fauna_rabbit"];
-var numTerreins = terreins.length;
-for (var i = 0; i < numTerreins; i++)
-	terreins.push("temp_grass_plants");
-textueByHeight.push({"upperHeightLimit": waterHeightAdjusted + 5/6 * (heightRange.max - waterHeightAdjusted), "terrain": terreins});
-// Unpassable woods
-textueByHeight.push({"upperHeightLimit": waterHeightAdjusted + 6/6 * (heightRange.max - waterHeightAdjusted),
+var numTerreins = terrains.length;
+for (var i = 0; i < numTerreins; ++i)
+	terrains.push("temp_grass_plants");
+textueByHeight.push({ "upperHeightLimit": waterHeightAdjusted + 5/6 * (heightRange.max - waterHeightAdjusted), "terrain": terrains });
+
+/**
+ * Impassable woods
+ */
+textueByHeight.push({ "upperHeightLimit": waterHeightAdjusted + 6/6 * (heightRange.max - waterHeightAdjusted),
 	"terrain": ["temp_grass_mossy|gaia/flora_tree_oak", "temp_forestfloor_pine|gaia/flora_tree_pine",
 	"temp_grass_mossy|gaia/flora_tree_oak", "temp_forestfloor_pine|gaia/flora_tree_pine",
 	"temp_mud_plants|gaia/flora_tree_dead", "temp_plants_bog|gaia/flora_tree_oak_large",
-	"temp_dirt_gravel_plants|gaia/flora_tree_aleppo_pine", "temp_forestfloor_autumn|gaia/flora_tree_carob"]});
+	"temp_dirt_gravel_plants|gaia/flora_tree_aleppo_pine", "temp_forestfloor_autumn|gaia/flora_tree_carob"] });
 var minTerrainDistToBorder = 3;
 
-// Time check 1
+/**
+ * Time check 1
+ */
 timeArray.push(new Date().getTime());
 RMS.SetProgress(5);
 
-
-// START THE GIANT WHILE LOOP:
-// - Generate Heightmap
-// - Search valid start position tiles
-// - Choose a good start position derivation (largest distance between closest players)
-// - Restart the loop if start positions are invalid or two players are to close to each other
+/**
+ * START THE GIANT WHILE LOOP:
+ * - Generate Heightmap
+ * - Search valid start position tiles
+ * - Choose a good start position derivation (largest distance between closest players)
+ * - Restart the loop if start positions are invalid or two players are to close to each other
+ */
 var goodStartPositionsFound = false;
 var minDistBetweenPlayers = 16 + mapSize / 16; // Don't set this higher than 25 for tiny maps! It will take forever with 8 players!
 var enoughTiles = false;
 var tries = 0;
 while (!goodStartPositionsFound)
 {
-	tries++;
+	++tries;
 	log("Starting giant while loop try " + tries);
 	// Generate reliefmap
 	var myReliefmap = getRandomReliefmap(heightRange.min, heightRange.max);
-	for (var i = 0; i < 50 + mapSize/4; i++) // Cycles depend on mapsize (more cycles -> bigger structures)
+	for (var i = 0; i < 50 + mapSize/4; ++i) // Cycles depend on mapsize (more cycles -> bigger structures)
 		myReliefmap = getHeightErrosionedReliefmap(myReliefmap, 1);
 	myReliefmap = getRescaledReliefmap(myReliefmap, heightRange.min, heightRange.max);
 	setReliefmap(myReliefmap);
@@ -217,18 +259,18 @@
 	var lowerHeightLimit = textueByHeight[3].upperHeightLimit;
 	var upperHeightLimit = textueByHeight[6].upperHeightLimit;
 	// Check for valid points by height
-	for (var x = distToBorder + minTerrainDistToBorder; x < mapSize - distToBorder - minTerrainDistToBorder; x++)
+	for (var x = distToBorder + minTerrainDistToBorder; x < mapSize - distToBorder - minTerrainDistToBorder; ++x)
 	{
-		for (var y = distToBorder + minTerrainDistToBorder; y < mapSize - distToBorder - minTerrainDistToBorder; y++)
+		for (var y = distToBorder + minTerrainDistToBorder; y < mapSize - distToBorder - minTerrainDistToBorder; ++y)
 		{
 			var actualHeight = getHeight(x, y);
 			if (actualHeight > lowerHeightLimit && actualHeight < upperHeightLimit)
 			{
 				// Check for points within a valid area by height (rectangular since faster)
 				var isPossible = true;
-				for (var offX = - neededDistance; offX <= neededDistance; offX++)
+				for (var offX = - neededDistance; offX <= neededDistance; ++offX)
 				{
-					for (var offY = - neededDistance; offY <= neededDistance; offY++)
+					for (var offY = - neededDistance; offY <= neededDistance; ++offY)
 					{
 						var testHeight = getHeight(x + offX, y + offY);
 						if (testHeight <= lowerHeightLimit || testHeight >= upperHeightLimit)
@@ -252,7 +294,7 @@
 	// Reduce to tiles in a circle of mapSize / 2 distance to the center (to avoid players placed in corners)
 	var possibleStartPositionsTemp = [];
 	var maxDistToCenter = mapSize / 2;
-	for (var i = 0; i < possibleStartPositions.length; i++)
+	for (var i = 0; i < possibleStartPositions.length; ++i)
 	{
 		var deltaX = possibleStartPositions[i][0] - mapSize / 2;
 		var deltaY = possibleStartPositions[i][1] - mapSize / 2;
@@ -270,19 +312,19 @@
 	var maxDistToResources = distToBorder; // Has to be <= distToBorder!
 	var minNumLowTiles = 10;
 	var minNumHighTiles = 10;
-	for (var i = 0; i < possibleStartPositions.length; i++)
+	for (var i = 0; i < possibleStartPositions.length; ++i)
 	{
 		var numLowTiles = 0;
 		var numHighTiles = 0;
-		for (var dx = - maxDistToResources; dx < maxDistToResources; dx++)
+		for (var dx = - maxDistToResources; dx < maxDistToResources; ++dx)
 		{
-			for (var dy = - maxDistToResources; dy < maxDistToResources; dy++)
+			for (var dy = - maxDistToResources; dy < maxDistToResources; ++dy)
 			{
 				var testHeight = getHeight(possibleStartPositions[i][0] + dx, possibleStartPositions[i][1] + dy);
 				if (testHeight < lowerHeightLimit)
-					numLowTiles++;
+					++numLowTiles;
 				if (testHeight > upperHeightLimit)
-					numHighTiles++;
+					++numHighTiles;
 				if (numLowTiles > minNumLowTiles && numHighTiles > minNumHighTiles)
 					break;
 			}
@@ -311,22 +353,22 @@
 		// Get some random start location derivations. NOTE: Itterating over all possible derivations is just to much (valid points ** numPlayers)
 		var maxTries = 100000; // floor(800000 / (Math.pow(numPlayers, 2) / 2));
 		var possibleDerivations = [];
-		for (var i = 0; i < maxTries; i++)
+		for (var i = 0; i < maxTries; ++i)
 		{
 			var vector = [];
-			for (var p = 0; p < numPlayers; p++)
+			for (var p = 0; p < numPlayers; ++p)
 				vector.push(randInt(possibleStartPositions.length));
 			possibleDerivations.push(vector);
 		}
 		
 		// Choose the start location derivation with the greatest minimum distance between players
 		var maxMinDist = 0;
-		for (var d = 0; d < possibleDerivations.length; d++)
+		for (var d = 0; d < possibleDerivations.length; ++d)
 		{
 			var minDist = 2 * mapSize;
-			for (var p1 = 0; p1 < numPlayers - 1; p1++)
+			for (var p1 = 0; p1 < numPlayers - 1; ++p1)
 			{
-				for (var p2 = p1 + 1; p2 < numPlayers; p2++)
+				for (var p2 = p1 + 1; p2 < numPlayers; ++p2)
 				{
 					if (p1 != p2)
 					{
@@ -358,26 +400,28 @@
 	} // End of derivation check
 } // END THE GIANT WHILE LOOP
 
-// Time check 2
+/**
+ * Time check 2
+ */
 timeArray.push(new Date().getTime());
 RMS.SetProgress(60);
 
 
-////////
-// Paint terrain by height and add props
-////////
+/**
+ * Paint terrain by height and add props
+ */
 
 var propDensity = 1; // 1 means as determined in the loop, less for large maps as set below
 if (mapSize > 500)
 	propDensity = 1/4;
 else if (mapSize > 400)
 	propDensity = 3/4;
-for(var x = minTerrainDistToBorder; x < mapSize - minTerrainDistToBorder; x++)
+for(var x = minTerrainDistToBorder; x < mapSize - minTerrainDistToBorder; ++x)
 {
-	for (var y = minTerrainDistToBorder; y < mapSize - minTerrainDistToBorder; y++)
+	for (var y = minTerrainDistToBorder; y < mapSize - minTerrainDistToBorder; ++y)
 	{
 		var textureMinHeight = heightRange.min;
-		for (var i = 0; i < textueByHeight.length; i++)
+		for (var i = 0; i < textueByHeight.length; ++i)
 		{
 			if (getHeight(x, y) >= textureMinHeight && getHeight(x, y) <= textueByHeight[i].upperHeightLimit)
 			{
@@ -488,20 +532,22 @@
 	}
 }
 
-// Time check 3
+/**
+ * Time check 3
+ */
 timeArray.push(new Date().getTime());
 RMS.SetProgress(90);
 
 
-////////
-// Place players and start resources
-////////
+/**
+ * Place players and start resources
+ */
 
-for (var p = 0; p < numPlayers; p++)
+for (var p = 0; p < numPlayers; ++p)
 {
 	var actualX = possibleStartPositions[bestDerivation[p]][0];
 	var actualY = possibleStartPositions[bestDerivation[p]][1];
-	placeCivDefaultEntities(actualX, actualY, p + 1, BUILDING_ANGlE, {"iberWall" : false});
+	placeCivDefaultEntities(actualX, actualY, p + 1, BUILDING_ANGlE, { "iberWall" : false });
 	// Place some start resources
 	var uDist = 8;
 	var uSpace = 1;
@@ -509,7 +555,7 @@
 	{
 		var uAngle = BUILDING_ANGlE - PI * (2-j) / 2;
 		var count = 4;
-		for (var numberofentities = 0; numberofentities < count; numberofentities++)
+		for (var numberofentities = 0; numberofentities < count; ++numberofentities)
 		{
 			var ux = actualX + uDist * cos(uAngle) + numberofentities * uSpace * cos(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * cos(uAngle + PI/2));
 			var uz = actualY + uDist * sin(uAngle) + numberofentities * uSpace * sin(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * sin(uAngle + PI/2));
@@ -521,17 +567,22 @@
 	}
 }
 
-
-// Export map data
+/**
+ * Export map data
+ */
 ExportMap();
 
-// Time check 7
+/**
+ * Time check 7
+ */
 timeArray.push(new Date().getTime());
 
-// Calculate progress percentage with the time checks
+/**
+ * Calculate progress percentage with the time checks
+ */
 var generationTime = timeArray[timeArray.length - 1] - timeArray[0];
 log("Total generation time (ms): " + generationTime);
-for (var i = 0; i < timeArray.length; i++)
+for (var i = 0; i < timeArray.length; ++i)
 {
 	var timeSinceStart = timeArray[i] - timeArray[0];
 	var progressPercentage = 100 * timeSinceStart / generationTime;
